Unit AET1R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, AA02C_p, UTAE12_p;

procedure AET1R(NM :Integer; N :Integer; LOW :Integer;
                IGH :Integer; var H :Array of Real;
                var WR :Array of Real; var WI :Array of Real;
                var Z :Array of Real; var IERR :Integer);

implementation

procedure AET1R(NM :Integer; N :Integer; LOW :Integer;
                IGH :Integer; var H :Array of Real;
                var WR :Array of Real; var WI :Array of Real;
                var Z :Array of Real; var IERR :Integer);
var
EN,ENM2,I,II,ITS,J,JJ,K,L,LL,M,MM,MP2,NA,NN :Integer;
AC2,AR2,F,MACHEP,NORM,P,Q,R,RA,S,SA,T,VI,VR,W,X,Y,ZZ :Real;
LOG,NOTLAS :Boolean;
const
SYS056 :Real = 1.175495E-38;
SYS051 :Real = 1.192093E-07;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140,_150,
_160,_170,_180,_190,_200,_210,_220,_230,_240,_250,_260,_270,_280,_290,
_300,_310,_320,_330,_340,_350,_360,_370,_380,_390,_400,_410,_420,_430,
_440,_450,_460,_470,_480,_490,_500,_510,_520,_530,_540,_550,_560,_570;
begin
{      SYS056 = SYS055 }
MACHEP := SYS051;
IERR := 0;
NORM := 0.0;
K := 1;
for I:=1 to N do
 begin
  for J:=1 to N do
   begin
    Z[(I-1)+(J-1)*NM] := 0.0;
_10:
   end;
  Z[(I-1)+(I-1)*NM] := 1.0;
_20:
 end;
for I:=1 to N do
 begin
  for J:=K to N do
   begin
    NORM := NORM + Abs(H[(I-1)+(J-1)*NM]);
_30:
   end;
  K := I;
  if ( I >=  LOW ) and (  I <=  IGH ) 
   then goto _40;
  WR[I-1] := H[(I-1)+(I-1)*NM];
  WI[I-1] := 0.0;
_40:
 end;
EN := IGH;
T := 0.0;
_50:
if ( EN <  LOW ) 
 then goto _320;
ITS := 0;
NA := EN - 1;
ENM2 := NA - 1;
_60:
for LL:=LOW to EN do
 begin
  L := EN + LOW - LL;
  if ( L =  LOW ) 
   then goto _80;
  S := ( Abs(H[(L-2)+(L-2)*NM]) +  Abs(H[(L-1)+(L-1)*NM]))*MACHEP;
  if ( S =  0.0 )  
   then S := NORM*MACHEP;
  if ( Abs(H[(L-1)+(L-2)*NM]) <=  S ) 
   then goto _80;
_70:
 end;
_80:
X := H[(EN-1)+(EN-1)*NM];
if ( L =  EN ) 
 then goto _250;
Y := H[(NA-1)+(NA-1)*NM];
W := H[(EN-1)+(NA-1)*NM]*H[(NA-1)+(EN-1)*NM];
if ( L =  NA ) 
 then goto _260;
if ( ITS =  30 ) 
 then goto _560;
if ( ITS <>  10 ) and (  ITS <>  20 ) 
 then goto _100;
T := T + X;
for I:=LOW to EN do
 begin
  H[(I-1)+(I-1)*NM] := H[(I-1)+(I-1)*NM] - X;
_90:
 end;
S := Abs(H[(EN-1)+(NA-1)*NM]) +  Abs(H[(NA-1)+(ENM2-1)*NM]);
X := 0.75*S;
Y := X;
X := -0.4375*S*S;
_100:
ITS := ITS + 1;
{ ******OCK BYX COCEHX MAX O BEHE }
{      AOHAHX EMEHTOB. }
{      M=EN-2,L,-1 }
for MM:=L to ENM2 do
 begin
  M := ENM2 + L - MM;
  ZZ := H[(M-1)+(M-1)*NM];
  R := X - ZZ;
  S := Y - ZZ;
  P := (R*S - W)/H[(M+0)+(M-1)*NM] + H[(M-1)+(M+0)*NM];
  Q := H[(M+0)+(M+0)*NM] - ZZ - R - S;
  R := H[(M+1)+(M+0)*NM];
  S := Abs(P) +  Abs(Q) +  Abs(R);
  P := P/S;
  Q := Q/S;
  R := R/S;
  if ( M =  L ) 
   then goto _120;
  if ( Abs(H[(M-1)+(M-2)*NM])*( Abs(Q) +  Abs(R)
       ) <=  MACHEP* Abs(P)*( Abs(H[(M-2)+(M-2)*NM])
       +  Abs(ZZ) +  Abs(H[(M+0)+(M+0)*NM])))
   then goto _120;
_110:
 end;
_120:
MP2 := M + 2;
for I:=MP2 to EN do
 begin
  H[(I-1)+(I-3)*NM] := 0.0;
  if ( I =  MP2 ) 
   then goto _130;
  H[(I-1)+(I-4)*NM] := 0.0;
_130:
 end;
for K:=M to NA do
 begin
  NOTLAS := ( K <>  NA );
  LOG := ( not  NOTLAS );
  if ( K =  M ) 
   then goto _150;
  P := H[(K-1)+(K-2)*NM];
  Q := H[(K+0)+(K-2)*NM];
  R := 0.0;
  if ( NOTLAS ) 
   then R := H[(K+1)+(K-2)*NM];
  X := Abs(P) +  Abs(Q) +  Abs(R);
  if ( X >  SYS056 ) 
   then goto _140;
  H[(K-1)+(K-2)*NM] := 0.0;
  H[(K+0)+(K-2)*NM] := 0.0;
  if ( NOTLAS ) 
   then H[(K+1)+(K-2)*NM] := 0.e0;
  goto _240;
_140:
  P := P/X;
  Q := Q/X;
  R := R/X;
_150:
  S := Sign(Sqrt(P*P+Q*Q+R*R),P);
  if ( K =  M ) 
   then goto _160;
  H[(K-1)+(K-2)*NM] := -S*X;
  goto _170;
_160:
  if ( L <>  M ) 
   then H[(K-1)+(K-2)*NM] := -H[(K-1)+(K-2)*NM];
_170:
  P := P + S;
  X := P/S;
  Y := Q/S;
  ZZ := R/S;
  Q := Q/P;
  R := R/P;
{ ******PEOPAOBAHE CTPOK }
  for J:=K to N do
   begin
    P := H[(K-1)+(J-1)*NM] + Q*H[(K+0)+(J-1)*NM];
    if ( LOG ) 
     then goto _180;
    P := P + R*H[(K+1)+(J-1)*NM];
    H[(K+1)+(J-1)*NM] := H[(K+1)+(J-1)*NM] - P*ZZ;
_180:
    H[(K+0)+(J-1)*NM] := H[(K+0)+(J-1)*NM] - P*Y;
_190:
   end;
  H[(K-1)+(J-1)*NM] := H[(K-1)+(J-1)*NM] - P*X;
  J := Min0(EN,K+3);
  for I:=1 to J do
   begin
    P := X*H[(I-1)+(K-1)*NM] + Y*H[(I-1)+(K+0)*NM];
    if ( LOG ) 
     then goto _200;
    P := P + ZZ*H[(I-1)+(K+1)*NM];
    H[(I-1)+(K+1)*NM] := H[(I-1)+(K+1)*NM] - P*R;
_200:
    H[(I-1)+(K+0)*NM] := H[(I-1)+(K+0)*NM] - P*Q;
    H[(I-1)+(K-1)*NM] := H[(I-1)+(K-1)*NM] - P;
_210:
   end;
  for I:=LOW to IGH do
   begin
    P := X*Z[(I-1)+(K-1)*NM] + Y*Z[(I-1)+(K+0)*NM];
    if ( LOG ) 
     then goto _220;
    P := P + ZZ*Z[(I-1)+(K+1)*NM];
    Z[(I-1)+(K+1)*NM] := Z[(I-1)+(K+1)*NM] - P*R;
_220:
    Z[(I-1)+(K+0)*NM] := Z[(I-1)+(K+0)*NM] - P*Q;
    Z[(I-1)+(K-1)*NM] := Z[(I-1)+(K-1)*NM] - P;
_230:
   end;
_240:
 end;
goto _60;
{ ****** OHO COCTBEHHOE HAEHE ****** }
_250:
H[(EN-1)+(EN-1)*NM] := X + T;
WR[EN-1] := H[(EN-1)+(EN-1)*NM];
WI[EN-1] := 0.0;
EN := NA;
goto _50;
{ ****** BA COCTBEHHX HAEH ****** }
_260:
P := (Y - X)/2.0;
Q := P*P + W;
ZZ := Sqrt(Abs(Q));
H[(EN-1)+(EN-1)*NM] := X + T;
X := H[(EN-1)+(EN-1)*NM];
H[(NA-1)+(NA-1)*NM] := Y + T;
if ( Q <  0.0 ) 
 then goto _300;
{ ****** BEECTBEHHA APA ****** }
ZZ := P +  Sign(ZZ,P);
WR[NA-1] := X + ZZ;
WR[EN-1] := WR[NA-1];
if ( ZZ <>  0.0 )   
 then WR[EN-1] := X - W/ZZ;
WI[NA-1] := 0.0;
WI[EN-1] := 0.0;
X := H[(EN-1)+(NA-1)*NM];
S := Abs(X) +  Abs(ZZ);
P := X/S;
Q := ZZ/S;
R := Sqrt(P*P+Q*Q);
P := P/R;
Q := Q/R;
for J:=NA to N do
 begin
  ZZ := H[(NA-1)+(J-1)*NM];
  H[(NA-1)+(J-1)*NM] := Q*ZZ + P*H[(EN-1)+(J-1)*NM];
  H[(EN-1)+(J-1)*NM] := Q*H[(EN-1)+(J-1)*NM] - P*ZZ;
_270:
 end;
{ ****** PEOPAOBAHE CTOOB****** }
for I:=1 to EN do
 begin
  ZZ := H[(I-1)+(NA-1)*NM];
  H[(I-1)+(NA-1)*NM] := Q*ZZ + P*H[(I-1)+(EN-1)*NM];
  H[(I-1)+(EN-1)*NM] := Q*H[(I-1)+(EN-1)*NM] - P*ZZ;
_280:
 end;
for I:=LOW to IGH do
 begin
  ZZ := Z[(I-1)+(NA-1)*NM];
  Z[(I-1)+(NA-1)*NM] := Q*ZZ + P*Z[(I-1)+(EN-1)*NM];
  Z[(I-1)+(EN-1)*NM] := Q*Z[(I-1)+(EN-1)*NM] - P*ZZ;
_290:
 end;
goto _310;
{ ****** KOMEKCHA APA ****** }
_300:
WR[NA-1] := X + P;
WR[EN-1] := X + P;
WI[NA-1] := ZZ;
WI[EN-1] := -ZZ;
_310:
EN := ENM2;
goto _50;
{ ****** }
_320:
if ( NORM =  0.0 )   
 then goto _570;
for NN:=1 to N do
 begin
  EN := N + 1 - NN;
  P := WR[EN-1];
  Q := WI[EN-1];
  NA := EN - 1;
  if ( Q ) < 0
   then goto _400
   else if ( Q ) > 0
         then goto _500
         else goto _330;
{ ****** BEECTBEHH BEKTOP ****** }
_330:
  M := EN;
  H[(EN-1)+(EN-1)*NM] := 1.0;
  if ( NA =  0 ) 
   then goto _500;
  for II:=1 to NA do
   begin
    I := EN - II;
    W := H[(I-1)+(I-1)*NM] - P;
    R := H[(I-1)+(EN-1)*NM];
    if ( M >  NA ) 
     then goto _350;
    for J:=M to NA do
     begin
      R := R + H[(I-1)+(J-1)*NM]*H[(J-1)+(EN-1)*NM];
_340:
     end;
_350:
    if ( WI[I-1] >=  0.0 ) 
     then goto _360;
    ZZ := W;
    S := R;
    goto _390;
_360:
    M := I;
    if ( WI[I-1] <>  0.0 ) 
     then goto _370;
    T := W;
    if ( Abs(W) <=  MACHEP*NORM ) 
     then T := MACHEP*NORM;
    H[(I-1)+(EN-1)*NM] := -R/T;
    goto _390;
{ ******PEEHE BEECTBEHHOO YPABHEH****** }
_370:
    X := H[(I-1)+(I+0)*NM];
    Y := H[(I+0)+(I-1)*NM];
    Q := (WR[I-1] - P)*(WR[I-1] - P) + WI[I-1]*WI[I-1];
    T := (X*S - ZZ*R)/Q;
    H[(I-1)+(EN-1)*NM] := T;
    if ( Abs(X) <=  Abs(ZZ) ) 
     then goto _380;
    H[(I+0)+(EN-1)*NM] := (-R - W*T)/X;
    goto _390;
_380:
    H[(I+0)+(EN-1)*NM] := (-S - Y*T)/ZZ;
_390:
   end;
  goto _500;
{ ******KOMEKCH BEKTOP****** }
_400:
  M := NA;
{ ****** }
  if ( Abs(H[(EN-1)+(NA-1)*NM]) <=   Abs(H[(NA-1)+(EN-1)*NM]) ) 
   then goto _410;
  H[(NA-1)+(NA-1)*NM] := Q/H[(EN-1)+(NA-1)*NM];
  H[(NA-1)+(EN-1)*NM] := -(H[(EN-1)+(EN-1)*NM] - P)/H[(EN-1)+(NA-1)*NM];
  goto _420;
_410:
  AC2 := -H[(NA-1)+(EN-1)*NM];
  AR2 := H[(NA-1)+(NA-1)*NM] - P;
  AA02C(0.0,AC2,AR2,Q,H[(NA-1)+(NA-1)*NM],H[(NA-1)+(EN-1)*NM]);
_420:
  H[(EN-1)+(NA-1)*NM] := 0.0;
  H[(EN-1)+(EN-1)*NM] := 1.0;
  ENM2 := NA - 1;
  if ( ENM2 =  0 ) 
   then goto _500;
  for II:=1 to ENM2 do
   begin
    I := NA - II;
    W := H[(I-1)+(I-1)*NM] - P;
    RA := 0.0;
    SA := H[(I-1)+(EN-1)*NM];
    for J:=M to NA do
     begin
      RA := RA + H[(I-1)+(J-1)*NM]*H[(J-1)+(NA-1)*NM];
      SA := SA + H[(I-1)+(J-1)*NM]*H[(J-1)+(EN-1)*NM];
_430:
     end;
    if ( WI[I-1] >=  0.0 ) 
     then goto _440;
    ZZ := W;
    R := RA;
    S := SA;
    goto _490;
_440:
    M := I;
    if ( WI[I-1] <>  0.0 ) 
     then goto _450;
    AA02C(-RA,-SA,W,Q,H[(I-1)+(NA-1)*NM],H[(I-1)+(EN-1)*NM]);
    goto _490;
{ ******PEEHE KOMEKCHOO YPABHEH****** }
_450:
    X := H[(I-1)+(I+0)*NM];
    Y := H[(I+0)+(I-1)*NM];
    VR := (WR[I-1] - P)*(WR[I-1] - P) + WI[I-1]*WI[I-1] - Q*Q;
    VI := (WR[I-1] - P)*2.0*Q;
    if ( EMax1( Abs(VR), Abs(VI)) >  MACHEP*NORM ) 
     then goto _460;
    F := Abs(W) +  Abs(Q) +  Abs(X) +  Abs(Y) +  Abs(ZZ);
    VR := MACHEP*NORM;
    AR2 := (X/F)*R - (ZZ/F)*RA + (Q/F)*SA;
    AC2 := (X/F)*S - (ZZ/F)*SA - (Q/F)*RA;
_460:
    AR2 := X*R - ZZ*RA + Q*SA;
    AC2 := X*S - ZZ*SA - Q*RA;
_470:
    AA02C(AR2,AC2,VR,VI,H[(I-1)+(NA-1)*NM],H[(I-1)+(EN-1)*NM]);
    if ( Abs(X) <=   Abs(ZZ) +  Abs(Q) ) 
     then goto _480;
    H[(I+0)+(NA-1)*NM] := (-RA - W*H[(I-1)+(NA-1)*NM] + Q*H[(I-1)+(EN-1)*NM])/X;
    H[(I+0)+(EN-1)*NM] := (-SA - W*H[(I-1)+(EN-1)*NM] - Q*H[(I-1)+(NA-1)*NM])/X;
    goto _490;
_480:
    AR2 := -R - Y*H[(I-1)+(NA-1)*NM];
    AC2 := -S - Y*H[(I-1)+(EN-1)*NM];
    AA02C(AR2,AC2,ZZ,Q,H[(I+0)+(NA-1)*NM],H[(I+0)+(EN-1)*NM]);
_490:
   end;
_500:
 end;
for I:=1 to N do
 begin
  if ( I >=  LOW ) and (  I <=  IGH ) 
   then goto _520;
  for J:=I to N do
   begin
    Z[(I-1)+(J-1)*NM] := H[(I-1)+(J-1)*NM];
_510:
   end;
_520:
 end;
for JJ:=LOW to N do
 begin
  J := N + LOW - JJ;
  M := Min0(J,IGH);
  for I:=LOW to IGH do
   begin
    ZZ := 0.0;
    for K:=LOW to M do
     begin
      ZZ := ZZ + Z[(I-1)+(K-1)*NM]*H[(K-1)+(J-1)*NM];
_530:
     end;
    Z[(I-1)+(J-1)*NM] := ZZ;
_540:
   end;
_550:
 end;
goto _570;
_560:
IERR := EN;
_570:
if ( IERR <>  0 ) 
 then UTAE12(IERR,N,3);
end;

end.
